using namespace std;

#include <iostream>
#include "testlib.h"

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int max_a_i = opt<int>("ax");
    int min_a_i = opt<int>("an");
    int a_i_w = opt<int>("aw");
    int max_n = opt<int>("n");
    int n_w = opt<int>("n_w");
    int max_k = opt<int>("k");

    int n = rnd.wnext(max_n, n_w) + 1;
    int k = rnd.next(0, max_k);

    printf("%d %d\n", n, k);

    for (int i = 0; i < n; ++i) {
        if (i > 0) {
            printf(" ");
        }
        int a_i = rnd.wnext(1 + max_a_i - min_a_i, a_i_w) + min_a_i;
        printf("%d", a_i);
    }
    printf("\n");

    return 0;
}
