using namespace std;

#include <bits/stdc++.h>

#define ll long long
#define ull unsigned ll
#define ld long double
#define pb push_back
#define mp make_pair
#define fori(i, n) for (int i = 0; i < n; ++i)
#define fori1(i, n) for (int i = 1; i <= n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(x) (x)*(x)
#define db_(x) cout << x << ' ';
#define db(x) cout << x << '\n';

ll solver() {
    int n, k;
    cin >> n >> k;
    vector<ll> a(n + 1), pref(n + 1), suf(n + 2);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        pref[i] = a[i] + pref[i - 1];
    }
    for (int i = n; i >= 1; --i) {
        suf[i] = suf[i + 1] + a[i];
    }
    ll max_ans = 0;
    for (int i = 1; i <= n; ++i) {
        ll cur_ans = pref[max(0, i - k - 1)] + suf[min(n + 1, i + k + 1)];
        cur_ans += a[i] * (1 + min(k, n - i) + min(k, i - 1));
        max_ans = max(max_ans, cur_ans);
    }
    return max_ans;
}

int main() {
#ifdef _DEBUG_INPUT_FILE
    freopen("test.in", "r", stdin);
#endif
    //    ios_base::sync_with_stdio(false);
    //    cin.tie(nullptr);
    //    cout.tie(nullptr);
    cout << solver();
    cout << '\n';
}