#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;

typedef tree<
int,
null_type,
less <int >,
rb_tree_tag,
tree_order_statistics_node_update > ord_set;


#define ll long long
#define pii pair < int, int >
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(),(x).end()

const int MOD = 1e9 + 7;

#ifdef LOCAL
    const int N = (1 << 15);
    const int inf = 1e9 + 7;
#else
    const int N = (4000000);
    const int inf = 1e9 + 7;
#endif // LOCAL
mt19937_64 gen(chrono::high_resolution_clock::now().time_since_epoch().count());
    int solve(int n, int k, int x){
        int dp[n + 2][k + 2][x + 1][2];
        for(int i = 0;i <= n; i++)
            for(int j = 0; j <= k; j++)
                for(int from = 0; from <= x; from++){
                    dp[i][j][from][0] = 0;
                    dp[i][j][from][1] = 0;
                }

        for(int from = 0; from <= x; from++)
            dp[0][0][from][0] = 1;

        for(int i = 0;i < n; i++){
            for(int j = 0; j <= k; j++){
                for(int from = 0; from < x; from++){
                    for(int f = 0; f < 2; f++){
                        for(int to = 0; to < x; to++){
                            int pl = 0;
                            if(f == 1 && to < from)
                                pl = 1;
                            int nf = (from >= to ? 0 : 1);
                            dp[i + 1][j + pl][to][nf] += dp[i][j][from][f];
                            dp[i + 1][j + pl][to][nf] %= MOD;
                        }
                    }
                }
            }
        }
        int ans = 0;
        for(int i = 0;i < x; i++){
            ans+=dp[n - 1][k][i][0];
            ans%=MOD;
            ans+=dp[n - 1][k][i][1];
            ans%=MOD;
        }
        return ans;
    }
main() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif // LOCAL
    ll n, k, x;
    cin >> n >> x >> k;
    cout << solve(n, k, x) << " ";
    return 0;
}
